use Modern::Perl;
use Test::More;

use lib 'lib';
use lib 't/lib';
use Test::WWW::Mechanize::Catalyst;

my @cookie_jar = ( {}, undef );

for my $cookie_jar (@cookie_jar) {
    my $mech = Test::WWW::Mechanize::Catalyst->new(
        catalyst_app => 'TestApp',
        cookie_jar   => $cookie_jar,
    );

    $mech->get_ok("/");
    $mech->content_is("i am index");

    $mech->get_ok("/is_session_restored");
    $mech->content_is("no");

    $mech->get_ok("/is_session_restored");
    $mech->content_is("no");

    $mech->get_ok("/session");
    $mech->content_is("yes");

    my $sid1 = do {
        $mech->get_ok("/sessionid");
        $mech->content;
    };

    $mech->get_ok("/is_session_restored");
    $mech->content_is("no");

    $mech->get_ok("/session_and_is_session_restored");
    $mech->content_is( $cookie_jar ? 'yes' : 'no' );

    my $sid2 = do {
        $mech->get_ok("/sessionid");
        $mech->content;
    };

    if ($cookie_jar) {
        is( $sid1, $sid2, 'sessionid' );
    }
    else {
        isnt( $sid1, $sid2, 'sessionid' );
    }
}

done_testing;
